"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
exports.__esModule = true;
exports.APP_ID = exports.shutdownIntercom = exports.showIntercomWindow = exports.initIntercomWindow = exports.loadIntercom = exports.setAppId = exports.createIntercomSSR = exports.trackEvent = exports.updateIntercom = void 0;
var load_script_1 = require("./load-script");
var has_intercom_1 = require("./has-intercom");
var APP_ID = "";
exports.APP_ID = APP_ID;
var widgetCdn = "https://widget.intercom.io/widget/";
function setAppId(id) {
    if (id) {
        exports.APP_ID = APP_ID = id;
    }
}
exports.setAppId = setAppId;
function updateIntercom(event, settings) {
    if (event === void 0) { event = "update"; }
    if (settings === void 0) { settings = null; }
    has_intercom_1.hasIntercom() && window.Intercom(event, settings);
}
exports.updateIntercom = updateIntercom;
function trackEvent(type, metadata) {
    if (metadata === void 0) { metadata = null; }
    has_intercom_1.hasIntercom() && window.Intercom("trackEvent", type, metadata);
}
exports.trackEvent = trackEvent;
function createIntercomSSR(appId) {
    if (appId === void 0) { appId = APP_ID; }
    return __awaiter(this, void 0, void 0, function () {
        var script, dataSource, scriptBody, error_1;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    script = "";
                    _a.label = 1;
                case 1:
                    _a.trys.push([1, 4, , 5]);
                    return [4, fetch("" + widgetCdn + appId)];
                case 2:
                    dataSource = _a.sent();
                    return [4, dataSource.text()];
                case 3:
                    scriptBody = _a.sent();
                    script = "<script type=\"text/javascript\" async=\"true\">" + scriptBody + "</script>";
                    return [3, 5];
                case 4:
                    error_1 = _a.sent();
                    console.error(error_1);
                    return [3, 5];
                case 5: return [2, script];
            }
        });
    });
}
exports.createIntercomSSR = createIntercomSSR;
function initIntercomWindow(_a) {
    var _b = _a.appId, appId = _b === void 0 ? APP_ID : _b, otherProps = __rest(_a, ["appId"]);
    var intercomProps = Object.assign({}, {
        api_base: "https://api-iam.intercom.io",
        app_id: appId
    }, otherProps);
    if (has_intercom_1.hasIntercom()) {
        if (window.intercomSettings && !window.intercomSettings.app_id) {
            window.intercomSettings = intercomProps;
        }
        window.Intercom("boot", intercomProps);
    }
}
exports.initIntercomWindow = initIntercomWindow;
function loadIntercom(_a) {
    var _b = _a.appId, appId = _b === void 0 ? APP_ID : _b, _c = _a.delay, delay = _c === void 0 ? 0 : _c, _d = _a.initWindow, initWindow = _d === void 0 ? true : _d, extra = __rest(_a, ["appId", "delay", "initWindow"]);
    setAppId(appId);
    if (extra.ssr) {
        return createIntercomSSR(appId);
    }
    else if (typeof window !== "undefined") {
        if (typeof window.Intercom === "function") {
            updateIntercom("reattach_activator");
            updateIntercom("update", window.intercomSettings);
        }
        else if (typeof document !== "undefined") {
            var intercomBase_1 = function () {
                intercomBase_1.c(arguments);
            };
            intercomBase_1.q = [];
            intercomBase_1.c = function (args) {
                intercomBase_1.q.push(args);
            };
            window.Intercom = intercomBase_1;
            var _e = extra || {}, callBack = _e.callBack, scriptType = _e.scriptType, email = _e.email, name_1 = _e.name, stripedProps = __rest(_e, ["callBack", "scriptType", "email", "name"]);
            var baseLoadProps_1 = {
                src: "" + widgetCdn + appId,
                callBack: callBack,
                initWindow: initWindow,
                initIntercomWindow: initIntercomWindow,
                scriptType: scriptType
            };
            var updateProps_1 = Object.assign({}, {
                email: email || null,
                appId: appId,
                name: name_1
            }, stripedProps);
            var onLoadScript = function () { return load_script_1.loadScript(baseLoadProps_1, updateProps_1); };
            delay ? setTimeout(onLoadScript, delay) : onLoadScript();
        }
        else {
            console.warn("intercom failed to load");
        }
    }
}
exports.loadIntercom = loadIntercom;
function showIntercomWindow() {
    has_intercom_1.hasIntercom() && window.Intercom("show");
}
exports.showIntercomWindow = showIntercomWindow;
function shutdownIntercom() {
    if (has_intercom_1.hasIntercom()) {
        window.Intercom("shutdown");
        delete window.Intercom;
        delete window.intercomSettings;
    }
}
exports.shutdownIntercom = shutdownIntercom;
//# sourceMappingURL=index.js.map